/*---------------------------------------------------------------------------*/

/*!  \file  common.h
     \brief  common header file.  */

/*---------------------------------------------------------------------------*/

/* Copyright (C) 2007,2008 Takashi Uneyama  */

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_COMMON_H
#define INCLUDE_COMMON_H

/*---------------------------------------------------------------------------*/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_STDDEF_H
#include <stddef.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifndef HAVE_MEMSET
void *memset(void * dest,int val,size_t len);
#endif
#ifndef HAVE_MEMCPY
void *memcpy(void *dest,const void *src,size_t n);
#endif
#ifndef HAVE_MEMPCPY
void *mempcpy(void *dest,const void *src,size_t len);
#endif
#ifndef HAVE_RENAME
int rename(const char *zfrom, const char *zto);
#endif

#ifndef FILENAME_BUFFERSIZE
#define FILENAME_BUFFERSIZE 0x100
#endif

#ifndef DEFAULT_INPUT_FILE
#define DEFAULT_INPUT_FILE "spreadsin.lua"
#endif

#ifndef TRUE
#define TRUE (!0)
#endif
#ifndef FALSE
#define FALSE (0)
#endif

#ifndef COPYRIGHT_STRING
#define COPYRIGHT_STRING "\
%s (%s) %s\n\
\n\
Copyright (C) 2007,2008 Takashi Uneyama\n\
This is free software; see the source for copying conditions.  There is NO\n\
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\
"
#endif

/*---------------------------------------------------------------------------*/
#endif

/*---------------------------------------------------------------------------*/
