dnl ---------------------------------------------------------------------------
dnl
dnl  dimension.m4
dnl
dnl ---------------------------------------------------------------------------
dnl
dnl  Copyright (C) 2007,2008 Takashi Uneyama
dnl
dnl  This program is free software; you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation; either version 2, or (at your option)
dnl  any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
dnl  USA.
dnl
dnl ---------------------------------------------------------------------------
dnl  VECTOR2
dnl    expand a sentense into 2 dimensional vector form.
dnl  $1  a vector sentense to be expanded into scalar sentenses.
define(`VECTOR2',`dnl
patsubst(`$1',`@@',`0')
patsubst(`$1',`@@',`1')')dnl
dnl ---------------------------------------------------------------------------
dnl  VECTOR3
dnl    expand a sentense into 3 dimensional vector form.
dnl  $1  a vector sentense to be expanded into scalar sentenses.
define(`VECTOR3',`dnl
patsubst(`$1',`@@',`0')
patsubst(`$1',`@@',`1')
patsubst(`$1',`@@',`2')')dnl
dnl ---------------------------------------------------------------------------
dnl  SYMMETRIC_TENSOR2
dnl    expand a sentense into 2 dimensional vector form.
dnl  $1  a vector sentense to be expanded into scalar sentenses.
define(`SYMMETRIC_TENSOR2',`dnl
patsubst(`patsubst(`patsubst(`$1',`@@',`0')',`@1@',`0')',`@2@',`0')
patsubst(`patsubst(`patsubst(`$1',`@@',`1')',`@1@',`1')',`@2@',`1')
patsubst(`patsubst(`patsubst(`$1',`@@',`2')',`@1@',`0')',`@2@',`1')')dnl
dnl ---------------------------------------------------------------------------
dnl  SYMMETRIC_TENSOR3
dnl    expand a sentense into 3 dimensional vector form.
dnl  $1  a vector sentense to be expanded into scalar sentenses.
define(`SYMMETRIC_TENSOR3',`dnl
patsubst(`patsubst(`patsubst(`$1',`@@',`0')',`@1@',`0')',`@2@',`0')
patsubst(`patsubst(`patsubst(`$1',`@@',`1')',`@1@',`1')',`@2@',`1')
patsubst(`patsubst(`patsubst(`$1',`@@',`2')',`@1@',`2')',`@2@',`2')
patsubst(`patsubst(`patsubst(`$1',`@@',`3')',`@1@',`0')',`@2@',`1')
patsubst(`patsubst(`patsubst(`$1',`@@',`4')',`@1@',`1')',`@2@',`2')
patsubst(`patsubst(`patsubst(`$1',`@@',`5')',`@1@',`2')',`@2@',`0')')dnl
dnl ---------------------------------------------------------------------------
dnl  SWITCH_FUNCTION
dnl    switch the function into one for the given dimension
dnl  $1  dimension
dnl  $2  a sentense for the function call
dnl  $3  a sentense for the default case
define(`SWITCH_FUNCTION',`dnl
    switch($1)
    {
        case 2:
            patsubst(`$2',`@D@',`2')
            break;

        case 3:
            patsubst(`$2',`@D@',`3')
            break;

        default:
            ifelse(`$3',`',break;,`$3'
            break;)
    }dnl
')dnl
dnl ---------------------------------------------------------------------------
dnl  PROTOTYPE_FUNCTIONS
dnl    create prototypes for functions of 2 and 3 dimensions
dnl  $1 a function prototypes to be expanded
define(`PROTOTYPE_FUNCTIONS',`dnl
patsubst(`$1',`@D@',`2')

patsubst(`$1',`@D@',`3')dnl
')dnl
dnl ---------------------------------------------------------------------------
dnl  EXPAND_FUNCTIONS
dnl    expand a function into definitions of functions of 2 and 3 dimensions
dnl  $1  a function inplementation to be expanded
define(`EXPAND_FUNCTIONS',`dnl
patsubst(`$1',`@D@',`2')

/*---------------------------------------------------------------------------*/
patsubst(`$1',`@D@',`3')dnl
')dnl
dnl ---------------------------------------------------------------------------
dnl ---------------------------------------------------------------------------
dnl  GENERATE_HEADER
dnl    generate a header for C source file.
dnl  $1  file name of the C source
dnl  $2  brief comment of the C source
define(`GENERATE_HEADER',`dnl
/*---------------------------------------------------------------------------*/

/*!  \file  $1
     \brief  $2  */

/*---------------------------------------------------------------------------*/

/* Copyright (C) 2007,2008 Takashi Uneyama  */

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/

/*  DO NOT EDIT THIS FILE. This file is generated from __file__.  */dnl
')dnl
dnl ---------------------------------------------------------------------------
