dnl ---------------------------------------------------------------------------
dnl
dnl  textread.c.m4
dnl
dnl ---------------------------------------------------------------------------
dnl
dnl  Copyright (C) 2007,2008 Takashi Uneyama
dnl
dnl  This program is free software; you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation; either version 2, or (at your option)
dnl  any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
dnl  USA.
dnl
dnl ---------------------------------------------------------------------------
include(`dimension.m4')`'dnl
GENERATE_HEADER(textread.c,
                read the field data from an ascii text file.)

#include "common.h"

#include <stdio.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif
#ifndef EXIT_FAILURE
#define EXIT_FAILURE 1
#endif

#ifdef HAVE_ZLIB_H
#include <zlib.h>
#endif

#include "particles.h"
#include "textread.h"
#include "zget.h"

#define STRING_BUFFERSIZE 0x100

/*---------------------------------------------------------------------------*/
PROTOTYPE_FUNCTIONS(`dnl
static void read_positions@D@_text(char *filename,soft_particles@D@ *particles);'`')

/*---------------------------------------------------------------------------*/
void read_positions_text(char *filename,soft_particles *particles)
{
    SWITCH_FUNCTION(particles->dimension,
                    read_positions@D@_text(filename,&(particles->particles@D@));)
}

/*---------------------------------------------------------------------------*/
EXPAND_FUNCTIONS(`dnl
void read_positions@D@_text(char *filename,soft_particles@D@ *particles)
{
    gzFile *fp;
    int i,j;
    static char buf[STRING_BUFFERSIZE];
    int d,n,m;

    if((filename == NULL) || (strlen(filename) == 0))
        return;

    fp = gzopen(filename,"rb");

        /*  check the header  */
    gzgetstring(fp,buf,STRING_BUFFERSIZE);
    if(strcmp(buf,"#") != 0)
    {
        goto error;
    }

    gzgetint(fp,&d);
    if(d != @D@)
    {
        goto error;
    }

    gzgetint(fp,&n);
    if(n != particles->n)
    {
        goto error;
    }

    gzgetstring(fp,buf,STRING_BUFFERSIZE);
    if(strcmp(buf,"#") != 0)
    {
        goto error;
    }

    for(i = 0;i < particles->n;i++)
    {
        gzgetint(fp,&m);
        if(m != particles->m[i])
        {
            goto error;
        }
    }


    for(i = 0;i < particles->n;i++)
    {
        for(j = 0;j < particles->m[i];j++)
        {
            VECTOR@D@(gzgetdouble(fp,&(particles->r[i][j][@@]));)
        }
    }

    gzclose(fp);
    return;


  error:
    gzclose(fp);

    fprintf(stderr,"cannot read data from a file ``%s'' (incorrect `format' or size mismatch)\n",filename);
    exit(EXIT_FAILURE);
}'`')

/*---------------------------------------------------------------------------*/
