/*---------------------------------------------------------------------------*/

/*!  \file  luaread.h
     \brief  read input Lua file for the simulator  */

/*---------------------------------------------------------------------------*/

/* Copyright (C) 2007,2008 Takashi Uneyama  */

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_LUAREAD_H
#define INCLUDE_LUAREAD_H

/*---------------------------------------------------------------------------*/
/*!  \brief  read data from input Lua file.
     \param  dimension  dimension of the simulation box.
     \param  n  number of particles.
     \param  m  number of output stress files.
     \param  dt  size of the time step between files.
     \param  save_stress_sequential  whether to save the stress sequentially.
     \param  stress_template  output stress file name template.
     \param  save_geometry_sequential  whether to save the geometry sequentially.
     \param  geometry_output  output geometry file name.  */
void read_input_lua(char *input_lua,int *dimension,int *n,int *m,double *dt,
                    int *save_stress_sequential,char **stress_template,
                    int *save_geometry_sequential,char **geometry_output);

/*---------------------------------------------------------------------------*/
#endif

/*---------------------------------------------------------------------------*/
